package VMware_KernelModuleService;
use WSMan::Stubs::Initializable;
use WSMan::Stubs::CIM_Service;
use strict;


@VMware_KernelModuleService::ISA = qw(_Initializable CIM_Service);


#===============================================================================
#			INITIALIZER
#===============================================================================

sub _init{
    my ($self, %args) = @_;
    $self->CIM_Service::_init();
    unless(exists $self->{invokableMethods}){
        $self->{invokableMethods} = {};
    }
    unless(exists $self->{id_keys}){
        $self->{id_keys} = ();
    }
    $self->{epr_name} = undef;  
    $self->{invokableMethods}->{DisableModule} = { input => ['ModuleName'], output => [] };
    $self->{invokableMethods}->{EnableModule} = { input => ['ModuleName'], output => [] };
    $self->{invokableMethods}->{LoadModule} = { input => ['ModuleName'], output => [] };
    $self->{invokableMethods}->{ListModules} = { input => [], output => ['ModuleNames'] };
    $self->{invokableMethods}->{GetModuleLoadParameter} = { input => ['ModuleName'], output => ['LoadParameter'] };
    $self->{invokableMethods}->{SetModuleLoadParameter} = { input => ['ModuleName', 'LoadParameter'], output => [] };
    @{$self->{id_keys}} = keys %{{ map { $_ => 1 } @{$self->{id_keys}} }};
    if(keys %args){
        $self->_subinit(%args);
    }
}


#===============================================================================


#===============================================================================
#           epr_name accessor method.
#===============================================================================

sub epr_name{
    my ($self, $newval) = @_;
    $self->{epr_name} = $newval if @_ > 1;
    return $self->{epr_name};
}
#===============================================================================


1;
